#ifndef H_DMD_MIXER_SINK
#define H_DMD_MIXER_SINK
/*
	mixer_sink: A catch-all message sink for lost communication.

	part of DerMixD
	(c)2009-2012 Thomas Orgis, licensed under GPLv2

	This was supposed to grow into a real background working thread, but that
	functionality got split off. So, this really is and was about simply catching
	messages nobody else would care for and dump them someplace (daemon's
	standard error output for now).
*/

#include "threads/threads.hxx"
#include "coms/comm_data.hxx"
#include <vector>
#include <string>

class mixer_sink: public dmd::thread
{
	public:
	comm_data comdat;
	mixer_sink();
	~mixer_sink();
	void thread_work();

	private:
	std::vector<std::string*> msgs;
};

#endif
