#ifndef DMD_H_OUT_TEXT
#define DMD_H_OUT_TEXT

/*
	out_text: text output device
	
	part of DerMixD
	(c)2005-2010 Thomas Orgis, licensed under GPLv2
	
	This is a device for debugging and maybe other weird interests.
	It writes the output into a ascii text file - lines with TAB-separated numbers.
	Nice to easily plot the result of mixing; not nice for storage;-)
*/

#include "out/output_file.hxx"
#include <string>
#include <fstream>

class text_output: public output_file
{
	private:
	std::ofstream file;

	public:
	 text_output();
	~text_output();

	bool do_write(const void* buf, size_t bytes);
	bool do_open(const std::string location);
	void do_close();
};

#endif
